Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushProgramTreeView.cs	(revision 15017)
@@ -0,0 +1,56 @@
+﻿using System.Windows.Forms;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Views {
+  using System.Collections.Generic;
+  using System.Linq;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
+  public partial class PushProgramTreeView : TreeView {
+    private const string PushProgramStringFormat = "List {0}@{1}";
+    private const string EmptyList = "Empty List";
+
+    public PushProgramTreeView() {
+      InitializeComponent();
+    }
+
+    public void LoadExpressions(IEnumerable<Expression> expressions) {
+      Nodes.Clear();
+      AddExpressions(expressions);
+    }
+
+    public void AddExpressions(IEnumerable<Expression> expressions) {
+      var nodes = expressions.Select(ToTreeNode).ToArray();
+      Nodes.AddRange(nodes);
+    }
+
+    private TreeNode ToTreeNode(Expression expression) {
+      var node = new TreeNode {
+        Text = GetNodeText(expression),
+        Tag = expression
+      };
+
+      if (expression.IsProgram) {
+        var program = (PushProgram)expression;
+        var subNodes = program.Expressions.Reverse().Select(ToTreeNode).ToArray();
+
+        node.Nodes.AddRange(subNodes);
+      }
+
+      return node;
+    }
+
+    private string GetNodeText(Expression expression) {
+      if (expression.IsProgram) {
+        var program = (PushProgram)expression;
+
+        if (program.IsEmpty)
+          return EmptyList;
+
+        return string.Format(PushProgramStringFormat, program.TotalExpressionCount, program.Depth);
+      }
+
+      return expression.StringRepresentation;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/RandomWalkTests.cs	(revision 15017)
@@ -17,8 +17,4 @@
   public class RandomWalkTests {
     private static void RandomWalk(BenchmarkSuiteDataDescriptor descriptor) {
-      var iterations = 2;
-      var best = double.MaxValue;
-      var random = new MersenneTwister(1337);
-
       var instance = new BenchmarkSuiteInstanceProvider();
       var data = instance.LoadData(descriptor);
@@ -34,38 +30,21 @@
 
       var pool = new PushInterpreterPool(config);
-      var bestProgram = Enumerable
-        .Range(0, iterations)
+      var best = Enumerable
+        .Range(0, 10)
         .AsParallel()
         .Select(_ => {
+          var random = new MersenneTwister(1337);
           var program = LinearCodeGenerator.RandomProgram(data.MaxSize, random, config);
           var result = evaluator.EvaluateTraining(pool, program, random);
 
           return new {
-            Quality = result.TotalQuality,
+            Quality = result.AvgQuality,
             Program = program
           };
         })
         .OrderBy(x => x.Quality)
-        .Select(x => x.Program)
         .First();
-      //  var program = RecursiveCodeGenerator.RandomProgram(data.MaxSize, random, config);
-      //  var avg = evaluator.EvaluateTraining(pool, program, random);
-
-      //  lock (lockObj) {
-      //    if (avg.TotalQuality < best) {
-      //      best = avg.TotalQuality;
-      //      bestProgram = program;
-      //    }
-      //  }
-      //});
-
-      var averageTestResult = evaluator.EvaluateTest(pool, bestProgram, random);
-      //var simplifiedProgram = Simplifier.Simplify(
-      //  bestProgram,
-      //  p => evaluator.EvaluateTraining(pool, p, random).TotalQuality);
-
-      Console.WriteLine("Training: {0}", best);
-      Console.WriteLine("RandomWalk: {0}", averageTestResult.TotalQuality);
-      //Console.WriteLine("Best program (simplified): {0}", simplifiedProgram);
+
+      Console.WriteLine("Training: {0}", best.Quality);
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Erc/ErcTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Erc/ErcTests.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Erc/ErcTests.cs	(revision 15017)
@@ -112,4 +112,25 @@
     [TestProperty("Time", "Short")]
     [TestCategory("ErcTests")]
+    public void StringStringErcValueTests() {
+      var options = new StringErcOptions(
+        new StringConstantErc(true, 1.0, "_1", "_2", "_3"));
+
+      Assert.IsTrue(options.IsEnabled);
+
+      var distribution = Enumerable.Range(0, 1000)
+        .Select(_ => options.GetErcValue(random))
+        .GroupBy(x => x)
+        .ToDictionary(group => group.Key, group => group.Count());
+
+      var estimatedRatio = 1.0 / 3.0;
+
+      Assert.IsTrue(IsAlmost(estimatedRatio, distribution["_1"] / 1000.0, tolerance));
+      Assert.IsTrue(IsAlmost(estimatedRatio, distribution["_2"] / 1000.0, tolerance));
+      Assert.IsTrue(IsAlmost(estimatedRatio, distribution["_3"] / 1000.0, tolerance));
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ErcTests")]
     public void MixedIntegerVectorErcValueTests() {
       var options = new IntegerVectorErcOptions(
@@ -133,4 +154,23 @@
     [TestProperty("Time", "Short")]
     [TestCategory("ErcTests")]
+    public void DisabledIntegerVectorErcValueTests() {
+      var options = new IntegerVectorErcOptions(
+        new IntegerVectorConstantsErc(false, 0.8, new[] { 1, 2, 3 }, new[] { 4, 5, 6 }),
+        new IntegerVectorConstantsErc(true, 0.2, new[] { 10, 11, 12 }, new[] { 13, 14, 15 }));
+
+      Assert.IsTrue(options.IsEnabled);
+
+      var distribution = Enumerable.Range(0, 1000)
+        .Select(_ => options.GetErcValue(random))
+        .GroupBy(x => x.All(_ => _ < 10) ? "constants1" : "constants2")
+        .ToDictionary(group => group.Key, group => group.Count());
+
+      Assert.IsFalse(distribution.ContainsKey("constants1"));
+      Assert.AreEqual(1000, distribution["constants2"]);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ErcTests")]
     public void MixedFloatVectorErcValueTests() {
       var options = new FloatVectorErcOptions(
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15017)
@@ -55,4 +55,12 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Data-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Encodings.IntegerVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Encodings.IntegerVectorEncoding-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Optimization-3.3.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -79,9 +87,13 @@
   </Choose>
   <ItemGroup>
-    <Compile Include="Benchmark\DataTests.cs" />
     <Compile Include="Benchmark\RandomWalkTests.cs" />
+    <Compile Include="Benchmark\SolutionTests.cs" />
     <Compile Include="Erc\ErcTests.cs" />
+    <Compile Include="Interpreter\Expressions\BooleanVectorExpressionsTests.cs" />
+    <Compile Include="Interpreter\Expressions\CharExpressionTests.cs" />
     <Compile Include="Interpreter\Expressions\CommonTests.cs" />
     <Compile Include="Interpreter\Expressions\ExampleTests.cs" />
+    <Compile Include="Interpreter\Expressions\FloatVectorExpressionTests.cs" />
+    <Compile Include="Interpreter\Expressions\IntegerVectorExpressionTests.cs" />
     <Compile Include="Interpreter\Expressions\NameExpressionTests.cs" />
     <Compile Include="Interpreter\Expressions\FloatExpressionTests.cs" />
@@ -90,7 +102,14 @@
     <Compile Include="Interpreter\Expressions\CodeExpressionTests.cs" />
     <Compile Include="Interpreter\Expressions\IntegerExpressionTests.cs" />
+    <Compile Include="Interpreter\Expressions\PrintExpressionTests.cs" />
+    <Compile Include="Interpreter\Expressions\PushProgramTests.cs" />
     <Compile Include="Interpreter\Expressions\StandardTests.cs" />
+    <Compile Include="Interpreter\Expressions\StringExpressionTests.cs" />
+    <Compile Include="Interpreter\Expressions\StringVectorExpressionTests.cs" />
+    <Compile Include="Interpreter\Expressions\VectorExpressionTests.cs" />
     <Compile Include="Interpreter\ExpressionTest.cs" />
+    <Compile Include="Problem\IndividualMapperTests.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Simplifier\SimplifierTests.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -108,5 +127,4 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup />
   <Choose>
     <When Condition="'$(VisualStudioVersion)' == '10.0' And '$(IsCodedUITest)' == 'True'">
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 15017)
@@ -1,16 +1,47 @@
 ﻿namespace HeuristicLab.Tests.Interpreter {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Boolean;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Float;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.FloatVector;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.IntegerVector;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.StringVector;
 
   using Microsoft.VisualStudio.TestTools.UnitTesting;
+  using Problems.ProgramSynthesis.Base.Erc;
+  using Problems.ProgramSynthesis.Base.Erc.Char;
+  using Problems.ProgramSynthesis.Base.Erc.Integer;
+  using Problems.ProgramSynthesis.Base.Erc.String;
+  using Problems.ProgramSynthesis.Push.Configuration;
+  using Problems.ProgramSynthesis.Push.Interpreter;
 
   public class ExpressionTest {
     protected PushInterpreter interpreter;
 
-    protected PushConfiguration configuration = new PushConfiguration { TopLevelPushCode = false };
+    protected PushConfiguration configuration = new PushConfiguration {
+      TopLevelPushCode = false,
+      ErcOptions = new ErcOptions {
+        ErcProbability = 0.05,
+        CharErcOptions = new CharErcOptions(new IntegerRangeErc(0x20, 0x7e)),
+        StringErcOptions = new StringErcOptions(new StringRandomErc {
+          IsEnabled = true,
+          AllowDigits = true,
+          NewStringProbability = 1,
+          AllowLowercaseLetters = true,
+          AllowUppercaseLetters = true
+        }),
+        IntegerErcOptions = new IntegerErcOptions(new IntegerRangeErc(-10000, 10000)),
+        FloatErcOptions = new FloatErcOptions(new FloatRangeErc(-10000, 10000)),
+        BooleanErcOptions = new BooleanErcOptions(new BooleanRandomErc(true, true, true)),
+        StringVectorErcOptions = new StringVectorErcOptions(
+          new StringVectorConstantsErc(new[] { "test", "123", "asdf", "a", "b" })),
+        IntegerVectorErcOptions = new IntegerVectorErcOptions(
+          new IntegerVectorConstantsErc(new[] { 0, -5, 10, 8, -3 })),
+        FloatVectorErcOptions = new FloatVectorErcOptions(
+          new FloatVectorConstantsErc(new[] { 0.0, -5.2, 10.3, 8.1, -3.4 }))
+      }
+    };
 
     [TestInitialize]
     public void BeforeTest() {
-      interpreter = new PushInterpreter(configuration);
+      interpreter = new PushInterpreter(1337, configuration);
     }
 
@@ -21,16 +52,23 @@
       int? booleanStack = 0,
       int? floatStack = 0,
-      int? integerStack = 0) {
+      int? integerStack = 0,
+      int? charStack = 0,
+      int? stringStack = 0,
+      int? integerVectorStack = 0,
+      int? floatVectorStack = 0,
+      int? booleanVectorStack = 0,
+      int? stringVectorStack = 0) {
       if (execStack.HasValue) Assert.AreEqual(execStack, interpreter.ExecStack.Count);
-
       if (codeStack.HasValue) Assert.AreEqual(codeStack, interpreter.CodeStack.Count);
-
       if (nameStack.HasValue) Assert.AreEqual(nameStack, interpreter.NameStack.Count);
-
       if (booleanStack.HasValue) Assert.AreEqual(booleanStack, interpreter.BooleanStack.Count);
-
       if (floatStack.HasValue) Assert.AreEqual(floatStack, interpreter.FloatStack.Count);
-
       if (integerStack.HasValue) Assert.AreEqual(integerStack, interpreter.IntegerStack.Count);
+      if (charStack.HasValue) Assert.AreEqual(charStack, interpreter.CharStack.Count);
+      if (stringStack.HasValue) Assert.AreEqual(stringStack, interpreter.StringStack.Count);
+      if (integerVectorStack.HasValue) Assert.AreEqual(integerVectorStack, interpreter.IntegerVectorStack.Count);
+      if (floatVectorStack.HasValue) Assert.AreEqual(floatVectorStack, interpreter.FloatVectorStack.Count);
+      if (booleanVectorStack.HasValue) Assert.AreEqual(booleanVectorStack, interpreter.BooleanVectorStack.Count);
+      if (stringVectorStack.HasValue) Assert.AreEqual(stringVectorStack, interpreter.StringVectorStack.Count);
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanVectorExpressionsTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanVectorExpressionsTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanVectorExpressionsTests.cs	(revision 15017)
@@ -0,0 +1,34 @@
+﻿using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Tests.Interpreter.Expressions {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class BooleanVectorExpressionsTests : VectorExpressionTests<bool> {
+    protected override string TypeName { get { return "BOOLEAN[]"; } }
+
+    protected override IPushStack<IReadOnlyList<bool>> Stack { get { return interpreter.BooleanVectorStack; } }
+    protected override IPushStack<bool> LiteralStack { get { return interpreter.BooleanStack; } }
+
+    protected override IReadOnlyList<bool>[] GetValues(int count) {
+      return Enumerable
+        .Range(0, count)
+        .Select(x => GetLiterals(interpreter.Configuration.MaxVectorLength / 2 - 1))
+        .ToArray();
+    }
+
+    protected override IReadOnlyList<bool> GetLiterals(int count) {
+      return Enumerable
+        .Range(0, count)
+        .Select(x => interpreter.Configuration.ErcOptions.BooleanErcOptions.GetErcValue(interpreter.Random))
+        .ToArray();
+    }
+
+    protected override void CheckOtherStacksAreEmpty() {
+      TestStackCounts(booleanVectorStack: null);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CharExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CharExpressionTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CharExpressionTests.cs	(revision 15017)
@@ -0,0 +1,115 @@
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
+  using System.Linq;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class CharExpressionTests : CommonTests<char> {
+    protected override string TypeName { get { return "CHAR"; } }
+
+    protected override IPushStack<char> Stack { get { return interpreter.CharStack; } }
+
+    protected override char[] GetValues(int count) {
+      return Enumerable
+        .Range(0, count)
+        .Select(_ => interpreter.Configuration.ErcOptions.CharErcOptions.GetErcValue(interpreter.Random))
+        .ToArray();
+    }
+
+    protected override void CheckOtherStacksAreEmpty() {
+      TestStackCounts(charStack: null);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("CharExpressionTest")]
+    public void TestIsWhitespace() {
+      interpreter.CharStack.Push(' ', '_');
+      interpreter.Run(new CharIsWhitespaceExpression());
+      interpreter.Run(new CharIsWhitespaceExpression());
+
+      Assert.IsTrue(interpreter.BooleanStack[0]);
+      Assert.IsFalse(interpreter.BooleanStack[1]);
+      TestStackCounts(booleanStack: 2);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("CharExpressionTest")]
+    public void TestIsLetter() {
+      interpreter.CharStack.Push('a', '_');
+      interpreter.Run(new CharIsLetterExpression());
+      interpreter.Run(new CharIsLetterExpression());
+
+      Assert.IsTrue(interpreter.BooleanStack[0]);
+      Assert.IsFalse(interpreter.BooleanStack[1]);
+      TestStackCounts(booleanStack: 2);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("CharExpressionTest")]
+    public void TestIsDigit() {
+      interpreter.CharStack.Push('1', 'a');
+      interpreter.Run(new CharIsDigitExpression());
+      interpreter.Run(new CharIsDigitExpression());
+
+      Assert.IsTrue(interpreter.BooleanStack[0]);
+      Assert.IsFalse(interpreter.BooleanStack[1]);
+      TestStackCounts(booleanStack: 2);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("CharExpressionTest")]
+    public void TestFromInteger() {
+      interpreter.IntegerStack.Push(1, -1, 129);
+      interpreter.Run(new CharFromIntegerExpression());
+      interpreter.Run(new CharFromIntegerExpression());
+      interpreter.Run(new CharFromIntegerExpression());
+
+      Assert.AreEqual(0x01, interpreter.CharStack[0]);
+      Assert.AreEqual(0x01, interpreter.CharStack[1]);
+      Assert.AreEqual(0x01, interpreter.CharStack[2]);
+      TestStackCounts(charStack: 3);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("CharExpressionTest")]
+    public void TestFromFloat() {
+      interpreter.FloatStack.Push(1.5, -1.5, 129.5);
+      interpreter.Run(new CharFromFloatExpression());
+      interpreter.Run(new CharFromFloatExpression());
+      interpreter.Run(new CharFromFloatExpression());
+
+      Assert.AreEqual(0x01, interpreter.CharStack[0]);
+      Assert.AreEqual(0x01, interpreter.CharStack[1]);
+      Assert.AreEqual(0x01, interpreter.CharStack[2]);
+      TestStackCounts(charStack: 3);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("CharExpressionTest")]
+    public void TestAllFromString() {
+      interpreter.StringStack.Push("test");
+      interpreter.Run(new CharAllFromStringExpression());
+
+      Assert.AreEqual('t', interpreter.CharStack[0]);
+      Assert.AreEqual('e', interpreter.CharStack[1]);
+      Assert.AreEqual('s', interpreter.CharStack[2]);
+      Assert.AreEqual('t', interpreter.CharStack[3]);
+      TestStackCounts(charStack: 4);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 15017)
@@ -430,5 +430,5 @@
 
       Assert.AreEqual(3, interpreter.IntegerStack.Top);
-      TestStackCounts(codeStack: 1, integerStack: 2);
+      TestStackCounts(integerStack: 1);
     }
 
@@ -455,5 +455,5 @@
       var prog = PushParser.Parse("( INTEGER.DUP INTEGER.+ )");
 
-      interpreter.IntegerStack.Push(2, 3);
+      interpreter.IntegerStack.Push(2, 4);
       interpreter.CodeStack.Push(prog);
       interpreter.Run(new CodeDoTimesExpression());
@@ -508,5 +508,5 @@
     public void TestNestedDoTimes() {
       interpreter.Run(
-        "( 3 CODE.QUOTE ( 2 3 CODE.QUOTE ( 2 INTEGER.* ) CODE.DO*TIMES INTEGER.+ ) CODE.DO*TIMES )");
+        "( 4 CODE.QUOTE ( 2 4 CODE.QUOTE ( 2 INTEGER.* ) CODE.DO*TIMES INTEGER.+ ) CODE.DO*TIMES )");
 
       Assert.AreEqual(128, interpreter.IntegerStack.Top);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 15017)
@@ -145,7 +145,7 @@
     public void Example10() {
       interpreter.IntegerStack.Push(5);
-      interpreter.Run("( 1 INTEGER.MAX 1 EXEC.DO*RANGE ( 2 INTEGER.* ) )");
-
-      Assert.AreEqual(2, interpreter.IntegerStack.Top);
+      interpreter.Run("( 1 INTEGER.MAX 1 EXEC.DO*RANGE ( 2 INTEGER.* INTEGER.* ) )");
+
+      Assert.AreEqual(3840, interpreter.IntegerStack.Top);
       Assert.IsTrue(interpreter.CodeStack.IsEmpty);
       Assert.IsTrue(interpreter.ExecStack.IsEmpty);
@@ -254,11 +254,11 @@
       interpreter.FloatStack.Push(2);
       interpreter.Run(@"( ARG FLOAT.DEFINE
-                                     EXEC.Y (
-                                       ARG FLOAT.*
-                                       1 INTEGER.-
-                                       INTEGER.DUP 1 INTEGER.>
-                                       EXEC.IF ( ) EXEC.POP
-                                     )
-                                   )");
+                          EXEC.Y (
+                            ARG FLOAT.*
+                            1 INTEGER.-
+                            INTEGER.DUP 1 INTEGER.>
+                            EXEC.IF ( ) EXEC.POP
+                          )
+                        )");
 
       Assert.AreEqual(1024, interpreter.FloatStack.Top, Delta);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 15017)
@@ -111,7 +111,7 @@
     public void TestNestedDoRange() {
       interpreter.Run(
-        "( 0 2 EXEC.DO*RANGE ( 1 INTEGER.+ 0 3 EXEC.DO*RANGE ( 1 INTEGER.+ INTEGER.* ) INTEGER.+ )");
+        "( 1 0 2 EXEC.DO*RANGE ( INTEGER.POP 1 1 4 EXEC.DO*RANGE INTEGER.* INTEGER.* ) )");
 
-      Assert.AreEqual(144, interpreter.IntegerStack.Top);
+      Assert.AreEqual(13824, interpreter.IntegerStack.Top);
       TestStackCounts(integerStack: 1);
     }
@@ -134,5 +134,5 @@
     [TestCategory("ExecExpressionTest")]
     public void TestNestedDoTimes() {
-      interpreter.Run("( 3 EXEC.DO*TIMES ( 2 3 EXEC.DO*TIMES ( 2 INTEGER.* ) INTEGER.+ )");
+      interpreter.Run("( 4 EXEC.DO*TIMES ( 2 4 EXEC.DO*TIMES ( 2 INTEGER.* ) INTEGER.+ )");
 
       Assert.AreEqual(128, interpreter.IntegerStack.Top);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatVectorExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatVectorExpressionTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatVectorExpressionTests.cs	(revision 15017)
@@ -0,0 +1,34 @@
+﻿using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Tests.Interpreter.Expressions {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class FloatVectorExpressionTests : VectorExpressionTests<double> {
+    protected override string TypeName { get { return "FLOAT[]"; } }
+
+    protected override IPushStack<IReadOnlyList<double>> Stack { get { return interpreter.FloatVectorStack; } }
+    protected override IPushStack<double> LiteralStack { get { return interpreter.FloatStack; } }
+
+    protected override IReadOnlyList<double>[] GetValues(int count) {
+      return Enumerable
+        .Range(0, count)
+        .Select(x => GetLiterals(interpreter.Configuration.MaxVectorLength / 2 - 1))
+        .ToArray();
+    }
+
+    protected override IReadOnlyList<double> GetLiterals(int count) {
+      return Enumerable
+        .Range(0, count)
+        .Select(x => interpreter.Configuration.ErcOptions.FloatErcOptions.GetErcValue(interpreter.Random))
+        .ToArray();
+    }
+
+    protected override void CheckOtherStacksAreEmpty() {
+      TestStackCounts(floatVectorStack: null);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerVectorExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerVectorExpressionTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerVectorExpressionTests.cs	(revision 15017)
@@ -0,0 +1,34 @@
+﻿using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Tests.Interpreter.Expressions {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class IntegerVectorExpressionTests : VectorExpressionTests<long> {
+    protected override string TypeName { get { return "INTEGER[]"; } }
+
+    protected override IPushStack<IReadOnlyList<long>> Stack { get { return interpreter.IntegerVectorStack; } }
+    protected override IPushStack<long> LiteralStack { get { return interpreter.IntegerStack; } }
+
+    protected override IReadOnlyList<long>[] GetValues(int count) {
+      return Enumerable
+        .Range(0, count)
+        .Select(x => GetLiterals(interpreter.Configuration.MaxVectorLength / 2 - 1))
+        .ToArray();
+    }
+
+    protected override IReadOnlyList<long> GetLiterals(int count) {
+      return Enumerable
+        .Range(0, count)
+        .Select(x => (long)interpreter.Configuration.ErcOptions.IntegerErcOptions.GetErcValue(interpreter.Random))
+        .ToArray();
+    }
+
+    protected override void CheckOtherStacksAreEmpty() {
+      TestStackCounts(integerVectorStack: null);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs	(revision 15017)
@@ -0,0 +1,23 @@
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
+  using System.Globalization;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class PrintExpressionTests : ExpressionTest {
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("PrintExpressionTest")]
+    public void TestPrintFloat() {
+      var value = 29.561570440978656;
+      interpreter.FloatStack.Push(value);
+      interpreter.Run(new FloatPrintExpression());
+
+      Assert.AreEqual(value.ToString("R", CultureInfo.InvariantCulture), interpreter.PrintStack.Top);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PushProgramTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PushProgramTests.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PushProgramTests.cs	(revision 15017)
@@ -0,0 +1,38 @@
+﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
+
+  using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+  [TestClass]
+  public class PushProgramTests : ExpressionTest {
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("PushProgramTests")]
+    public void TotalCountTest() {
+      var program = PushParser.ParseProgram("( 5 ( INTEGER.DUP FLOAT.+ FLOAT.- ) ( EXEC.DO ( EXEC.IF ) EXEC.Y ) INTEGER.+ )");
+
+      Assert.AreEqual(12, program.TotalCount);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("PushProgramTests")]
+    public void DepthTest() {
+      var program = PushParser.ParseProgram("( 5 ( INTEGER.DUP FLOAT.+ FLOAT.- ) ( EXEC.DO ( EXEC.IF ) EXEC.Y ) INTEGER.+ )");
+
+      Assert.AreEqual(3, program.Depth);
+    }
+
+    [TestMethod]
+    [TestProperty("Time", "Short")]
+    [TestCategory("ExpressionTest")]
+    [TestCategory("PushProgramTests")]
+    public void BranchesTest() {
+      var program = PushParser.ParseProgram("( 5 ( INTEGER.DUP FLOAT.+ FLOAT.- ) ( EXEC.DO ( EXEC.IF ) EXEC.Y ) INTEGER.+ )");
+
+      Assert.AreEqual(4, program.Branches);
+    }
+  }
+}
